#include "stdafx.h"
#include "HLinkTest.h"
#include "HLinkTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(suppress: 26455)
CHLinkTestDlg::CHLinkTestDlg(CWnd* pParent) : CDialog{CHLinkTestDlg::IDD, pParent},
                                              m_hIcon{AfxGetApp()->LoadIcon(IDR_MAINFRAME)}
{
}

void CHLinkTestDlg::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_CHECK2, m_ctrlCheck2);
  DDX_Control(pDX, IDC_CHECK1, m_ctrlCheck1);
  DDX_Control(pDX, IDC_WEB, m_ctrlWeb);
  DDX_Control(pDX, IDC_EMAIL, m_ctrlEmail);
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CHLinkTestDlg, CDialog) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
  ON_BN_CLICKED(IDC_CHECK1, &CHLinkTestDlg::OnCheck1)
  ON_BN_CLICKED(IDC_CHECK2, &CHLinkTestDlg::OnCheck2)
#ifdef _DEBUG //Only do the hatched dialog background in debug mode
  ON_WM_ERASEBKGND()
#endif
END_MESSAGE_MAP()

BOOL CHLinkTestDlg::OnInitDialog()
{
  //Let the base class do its thing
  __super::OnInitDialog();

  SetIcon(m_hIcon, TRUE);
  SetIcon(m_hIcon, FALSE);

  //Create the 2 hyperlink controls
  m_ctrlWeb.SetHyperLink(_T("http://www.naughter.com"));
  m_ctrlEmail.SetHyperLink(_T("mailto:pjna@naughter.com"));

  //Initially have the buttons checked
  m_ctrlCheck1.SetCheck(1);
  m_ctrlCheck2.SetCheck(1);

  return TRUE;
}

void CHLinkTestDlg::OnCheck1()
{
  m_ctrlEmail.EnableWindow(m_ctrlCheck1.GetCheck() == 1);
}

void CHLinkTestDlg::OnCheck2()
{
  m_ctrlWeb.EnableWindow(m_ctrlCheck2.GetCheck() == 1);
}

#pragma warning(suppress: 26429 26434)
BOOL CHLinkTestDlg::OnEraseBkgnd(CDC* pDC)
{
  //Validate our parameters
  ASSERT(pDC != nullptr);

  CRect r;
  GetClientRect(&r);
  CBrush br;
  br.CreateHatchBrush(HS_DIAGCROSS, RGB(192, 192, 192));
  pDC->FillRect(&r, &br);

  return TRUE;
}
